<id>
din1031:MemberColorLink
</id>

<version>
2.1.5
</version>

<edit file>
$sourcedir/Load.php
</edit file>

<search for>
	array loadMemberData(array members, bool is_name = false, string set = 'normal')
</search for>

<replace>
	array loadOnlineColors(array members, bool returnarray = true)
		- This function is for Modcreators who like to color the nicks if the MemberColorLink is installed
		  with this function the user can check if the function exists and load the colors if needed.
		  But please load so many ids as possible at one time, to reduce the database querys.
		  To Check if the function exist use if(function_exists('loadOnlineColors')) {}
		- return a array with follow informations
			array(id_member => array(online_color => '', colored_name => '', colored_link => '');
		- chache datas the global $color_profile (only the db data, not the array data above)
		- return "false" on nothing loaded!

	array loadMemberData(array members, bool is_name = false, string set = 'normal')
</replace>

<search for>
		'colored_name' => (!empty($profile['member_group_color']) || !empty($profile['post_group_color']) ? '<span style="color:'. ( !empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color'] ) .';">' : '' ) . $profile['realName'] . (!empty($profile['member_group_color']) || !empty($profile['post_group_color']) ? '</span>' : ''),
</search for>

<replace>
		'colored_name' => (!empty($profile['member_group_color']) || !empty($profile['post_group_color']) ? '<span style="color:'. ( !empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color'] ) .';">' : '' ) . $profile['realName'] . (!empty($profile['member_group_color']) || !empty($profile['post_group_color']) ? '</span>' : ''),
		'online_color' => (!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']),
</replace>

<search for>
// Load a theme, by ID.
</search for>

<replace>
//This is the universion load colors function, can be used by each person who need it :)
//I think it's intressting for mod Creators =D
//SMF 1.1.x Version

function load_onlineColors($users, $returnarray = true) {
	global $color_profile, $db_prefix, $modSettings;

	//Make something for sure :)
	if(!isset($color_profile))
		$color_profile = array();
	//Set a standard empty array for guest errors ;) (Deleted users, which are not resetet)
	if(!isset($color_profile[0]))
		$color_profile[0] = array('member_group_color' => '', 'post_group_color' => '');
	
	// Can't just look for no users :P.
	if (empty($users))
		return false;

	// Make sure it's an array.
	$users = !is_array($users) ? array($users) : array_unique($users);

	//Now i will use this as a chache, too
	$loaded_ids = array();
	$all_loaded_ids = array_keys($color_profile);
	//All the users that allready loaded
	$loaded_ids = array_intersect($all_loaded_ids, $users);
	//Now i need only the new users to load
	$users = array_diff($users, $all_loaded_ids);

	if(!empty($users)) {
		// Load the data.
		$request = db_query("
			SELECT
			mem.ID_MEMBER AS ID_MEMBER, mem.realName AS realName,
			mg.onlineColor AS member_group_color, IFNULL(mg.groupName, '') AS member_group,
			pg.onlineColor AS post_group_color, IFNULL(pg.groupName, '') AS post_group
			FROM {$db_prefix}members AS mem
			LEFT JOIN {$db_prefix}membergroups AS pg ON (pg.ID_GROUP = mem.ID_POST_GROUP)
			LEFT JOIN {$db_prefix}membergroups AS mg ON (mg.ID_GROUP = mem.ID_GROUP)
			WHERE mem.ID_MEMBER ".(count($users) == 1 ? " = '" . current($users) . "'" : " IN ('" . implode("', '", $users) . "')"), __FILE__, __LINE__);

		while ($row = mysql_fetch_assoc($request))
		{
			$loaded_ids[] = $row['ID_MEMBER'];
			$color_profile[$row['ID_MEMBER']] = $row;
		}
		mysql_free_result($request);
	}
	
	//Build the Array ;D
	$array = array();
	if(!empty($loaded_ids) && $returnarray == true) {
		global $txt, $scripturl;
		foreach($loaded_ids as $id) {
			$profile = $color_profile[$id];
			$onlineColor = !empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color'];
			$array[$id] = array(
				'id' => $id,
				'online_color' => $onlineColor,
				'colored_name' => (!empty($onlineColor) ? '<span style="color:'.$onlineColor.';">' : '' ) . $profile['realName'] . (!empty($onlineColor) ? '</span>' : ''),
				'colored_link' => '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"'.(!empty($onlineColor) ? ' style="color:'.$onlineColor.';"' : '').'>' . $profile['realName'] .'</a>',
			);
		}	
	}
	//Return that what should returned XD
	return (empty($loaded_ids) ? false : ($returnarray == true ? $array : $loaded_ids));
}

// Load a theme, by ID.
</replace>
