<id>
din1031:MemberColorLink
</id>

<version>
2.0.1
</version>

<edit file>
$sourcedir/ModSettings.php
</edit file>

<search for>
		array('rule'),
	);

	return $config_vars;
}
</search for>

<add before>
		array('rule'),
		array('heading', &$txt['MemberColorLinkHeadline']),
			// Setting for Member Color Link
			array('check', 'MemberColorLink'),
			array('check', 'MemberColorLatestMember'),
			array('check', 'MemberColorStats'),
			array('check', 'MemberColorWhoIsOnline'),
			array('rule'),
			array('check', 'MemberColorThreadOwner'),
			array('check', 'MemberColorThreadLastPost'),
			array('check', 'MemberColorThreadChild'),
			array('rule'),
			array('check', 'MemberColorBoardindex'),
			array('check', 'MemberColorBirthday'),
			array('rule'),
			array('check', 'MemberColorRecentOwner'),
			array('check', 'MemberColorRecentLastPost'),
			array('rule'),
			array('check', 'MemberColorInbox'),
			array('check', 'MemberColorOutbox'),
</add before>

<edit file>
$sourcedir/Load.php
</edit file>

<search for>
		'username' => &$profile['memberName'],
		'name' => &$profile['realName'],
</search for>

<replace>
		'username' => &$profile['memberName'],
		'name' => &$profile['realName'],
		'colored_name' => (!empty($profile['member_group_color']) || !empty($profile['post_group_color']) ? '<font color="'. ( !empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color'] ) .'">' : '' ) . $profile['realName'] . (!empty($profile['member_group_color']) || !empty($profile['post_group_color']) ? '</font>' : ''),
</replace>

<search for>
		'link' => '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '">' . $profile['realName'] . '</a>',
</search for>

<replace>
		'link' => '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '">' . (!empty($modSettings['MemberColorLink']) ? ( !empty($profile['member_group_color']) || !empty($profile['post_group_color']) ? '<font color="'. ( !empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color'] ) .'">' : '' ) : '' ) . $profile['realName'] . (!empty($modSettings['MemberColorLink']) && (!empty($profile['member_group_color']) || !empty($profile['post_group_color'])) ? '</font>' : '' ).'</a>',
		'colorless_link' => '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '">' . $profile['realName'] . '</a>',
</replace>

<edit file>
$sourcedir/MessageIndex.php
</edit file>

<search for>
	// Aren't children wonderful things?
	$result = db_query("
</search for>

<add before>
	//Set some standard Variables for the MemberColorLink
	$MemberSetColor = FALSE;
	if (!empty($modSettings['MemberColorThreadOwner']) || !empty($modSettings['MemberColorThreadLastPost']) || !empty($modSettings['MemberColorChild']) || (!empty($modSettings['MemberColorWhoIsOnline']) && !empty($settings['display_who_viewing'])))
		$MemberColor_ID_MEMBER = array();

</add before>

<search for>
				$theboards[] = $row_board['ID_BOARD'];
</search for>

<add after>

				//The Last Posts of the Children MemberColor.
				if (!empty($modSettings['MemberColorThreadChild']) && !empty($row_board['ID_MEMBER'])) {
						$MemberColor_ID_MEMBER[$row_board['ID_MEMBER']] = $row_board['ID_MEMBER'];
						$MemberSetColor = TRUE;
				}
</add after>
<search for>
			if (empty($row['showOnline']))
				$context['view_num_hidden']++;
		}
		$context['view_num_guests'] = mysql_num_rows($request) - count($context['view_members']);
		mysql_free_result($request);

		if (!$found_me)
</search for>

<replace>
				if (!empty($modSettings['MemberColorWhoIsOnline'])) {
					$MemberColor_ID_MEMBER[$row['ID_MEMBER']] = $row['ID_MEMBER'];
					$MemberSetColor = TRUE;
				}

				if (empty($row['showOnline']))
					$context['view_num_hidden']++;
			}
		$context['view_num_guests'] = mysql_num_rows($request) - count($context['view_members']);
		mysql_free_result($request);

		if (!$found_me)
</replace>

<search for>
		$topic_ids[] = $row['ID_TOPIC'];
</search for>

<add after>

		//I need to collect some IDs for the MemberColor :).
		if (!empty($modSettings['MemberColorThreadOwner']) && !empty($row['firstID_MEMBER'])) {
				$MemberColor_ID_MEMBER[$row['firstID_MEMBER']] = $row['firstID_MEMBER'];
				$MemberSetColor = TRUE;
		}
		//Oh i need the Last Post ID, too ;)
		if (!empty($modSettings['MemberColorThreadLastPost']) && !empty($row['lastID_MEMBER'])) {
				$MemberColor_ID_MEMBER[$row['lastID_MEMBER']] = $row['lastID_MEMBER'];
				$MemberSetColor = TRUE;
		}
</add after>

<search for>
		determineTopicClass($context['topics'][$row['ID_TOPIC']]);
	}
	mysql_free_result($result);
</search for>

<add after>

	//Now let's replace the orginal link to the Color Link ;)
	if ($MemberSetColor && !empty($MemberColor_ID_MEMBER)) {
		//Now Load the Missing global :)
		global $user_profile;

		loadMemberData($MemberColor_ID_MEMBER);
		$cmemcolid = NULL;

		//Need the Childs some Colors XD
		if (!empty($modSettings['MemberColorThreadChild']))
			if(!empty($theboards))
			foreach($theboards as $boardid_memcolor) {
				//My Childs need a Member Color ;)
				$cmemcolid = $context['boards'][$boardid_memcolor]['last_post']['member']['id'];
				$profile = &$user_profile[$cmemcolid];
				if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
					$context['boards'][$boardid_memcolor]['last_post']['member']['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><font color="'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).'">' . $profile['realName'] . '</font></a>';
			}
		//The Owner or the Last Post of the thread
		if (!empty($modSettings['MemberColorThreadOwner']) || $modSettings['MemberColorThreadLastPost'])
			foreach($topic_ids as $topicid_memcolor) {
				//First the Thread Owner Link
				if (!empty($modSettings['MemberColorThreadOwner'])) {
					$cmemcolid = $context['topics'][$topicid_memcolor]['first_post']['member']['id'];
					$profile = &$user_profile[$cmemcolid];
					if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
						$context['topics'][$topicid_memcolor]['first_post']['member']['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><font color="'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).'">' . $profile['realName'] . '</font></a>';
				}
				//Or the Last Post Link ;)
				if (!empty($modSettings['MemberColorThreadLastPost'])) {
					$cmemcolid = $context['topics'][$topicid_memcolor]['last_post']['member']['id'];
					$profile = &$user_profile[$cmemcolid];
					if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
						$context['topics'][$topicid_memcolor]['last_post']['member']['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><font color="'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).'">' . $profile['realName'] . '</font></a>';
				}
			}
		if (!empty($modSettings['MemberColorWhoIsOnline']) && !empty($context['view_members'])) 
			foreach($context['view_members'] as $key => $value) {
				if (!isset($keyx)) $keyx = $key;
				$profile = &$user_profile[$value['id']];
				//Let's replace Who is online colors...
				$hidden_user = $context['view_members'][$key]['hidden'];
				if(!empty($profile['member_group_color']) || !empty($profile['post_group_color'])) {
					$context['view_members'][$key]['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><font color="'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).'">' . $profile['realName'] . '</font></a>';
					//Somehow the 'view_members_list' must be the same as before *g*, i don't like the hidden users...
					if (!$hidden_user || allowedTo('moderate_forum')) { 
						$context['view_members_list'][$keyx] = ($hidden_user ? '<i>' : '').'<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><font color="'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).'">' . $profile['realName'] . '</font></a>'.($hidden_user ? '</i>' : '');
						$keyx++;
					}
				}
				elseif (!$hidden_user || allowedTo('moderate_forum'))
					$keyx++;
			}
	}
</add after>

<edit file>
$sourcedir/BoardIndex.php
</edit file>

<search for>
			'start' => 'new',
			'topic' => $row_board['ID_TOPIC']
		);
</search for>

<add after>
		if (!empty($modSettings['MemberColorBoardindex']) && !empty($row_board['ID_MEMBER'])) {
			$MemberColor_ID_MEMBER[$row_board['ID_MEMBER']] = $row_board['ID_MEMBER'];
			$MemberColor_board[$isChild ? $row_board['ID_PARENT'] : $row_board['ID_BOARD']] = array(
			'bid' => ($isChild ? $row_board['ID_PARENT'] : $row_board['ID_BOARD']),
			'cat' => $row_board['ID_CAT']);
		}
</add after>

<search for>
		// Determine a global most recent topic.
		if (!empty($row_board['posterTime']) && forum_time(true, $row_board['posterTime']) > $most_recent_topic['timestamp'])
			$most_recent_topic = array(
				'timestamp' => forum_time(true, $row_board['posterTime']),
				'ref' => &$this_category[$isChild ? $row_board['ID_PARENT'] : $row_board['ID_BOARD']]['last_post'],
			);
	}
	mysql_free_result($result_boards);
</search for>

<add after>
	//The latest member?
	if (!empty($modSettings['latestMember']) && !empty($modSettings['MemberColorLatestMember']))
		$MemberColor_ID_MEMBER[$modSettings['latestMember']] = $modSettings['latestMember'];

	// Know set the colors for the last post...
	if (!empty($MemberColor_ID_MEMBER)) {
		//Now i can Load the Missing global :)
		global $user_profile;

		loadMemberData($MemberColor_ID_MEMBER);
		$cmemcolid = NULL;

		//So the BoardIndex need colored links
		if (!empty($modSettings['MemberColorBoardindex']) && !empty($MemberColor_board))
			foreach($MemberColor_board as $boardid_memcolor) {
				$cmemcolid = $context['categories'][$boardid_memcolor['cat']]['boards'][$boardid_memcolor['bid']]['last_post']['member']['id'];
				$profile = &$user_profile[$cmemcolid];
				if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
					$context['categories'][$boardid_memcolor['cat']]['boards'][$boardid_memcolor['bid']]['last_post']['member']['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><font color="'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).'">' . $profile['realName'] . '</font></a>';
			}
	}
</add after>

<edit file>
$sourcedir/Calendar.php
</edit file>

<search for>
	$bday = array();
</search for>

<add after>
	//Set some standard Variables for the MemberColorLink
	$MemberSetColor = FALSE;
	if (!empty($modSettings['MemberColorBirthday'])) {
		$MemberColor_ID_MEMBER = array();
	}
</add after>

<search for>
		$bday[$age_year . substr($row['birthdate'], 4)][] = array(
			'id' => $row['ID_MEMBER'],
			'name' => $row['realName'],
			'age' => $row['birthYear'] > 0 && $row['birthYear'] <= $age_year ? $age_year - $row['birthYear'] : null,
			'is_last' => false
		);
	}
	mysql_free_result($result);
</search for>

<replace>
		$bday[$age_year . substr($row['birthdate'], 4)][] = array(
			'id' => $row['ID_MEMBER'],
			'name' => $row['realName'],
			'age' => $row['birthYear'] > 0 && $row['birthYear'] <= $age_year ? $age_year - $row['birthYear'] : null,
			'is_last' => false
		);

		//I need to collect some IDs for the MemberColor :).
		if (!empty($modSettings['MemberColorBirthday']) && !empty($row['ID_MEMBER'])) {
			$MemberColor_ID_MEMBER[$row['ID_MEMBER']] = $row['ID_MEMBER'];
			$MemberSetColor = TRUE;
		}
	}
	mysql_free_result($result);

	if ($MemberSetColor && !empty($MemberColor_ID_MEMBER)) {
		//No compatible Problems ;) (I hope it).
		global $user_profile;

		loadMemberData($MemberColor_ID_MEMBER);
		$cmemcolid = NULL;

		//So i need only the colors... hmmm why schould i not use only the $user_profiles for this... (The Calenderlink is diffrent)
		if (!empty($modSettings['MemberColorBirthday']))
			if (is_array($bday))
				foreach ($bday as $memcalkv => $memcalva)
					foreach ($memcalva as $memcalidkv => $memcalid) {
						$cmemcolid = $memcalid['id'];
						$bday[$memcalkv][$memcalidkv]['color'] = (!empty($user_profile[$cmemcolid]['member_group_color']) ? $user_profile[$cmemcolid]['member_group_color'] : (!empty($user_profile[$cmemcolid]['post_group_color']) ? $user_profile[$cmemcolid]['post_group_color'] : NULL));
					}
	}
</replace>

<edit file>
$sourcedir/Display.php
</edit file>

<search for>
			if (empty($row['showOnline']))
				$context['view_num_hidden']++;
		}

		// The number of guests is equal to the rows minus the ones we actually used ;).
		$context['view_num_guests'] = mysql_num_rows($request) - count($context['view_members']);
		mysql_free_result($request);

		if (!$found_me)
</search for>

<replace>
				if (!empty($modSettings['MemberColorWhoIsOnline'])) {
					$MemberColor_ID_MEMBER[$row['ID_MEMBER']] = $row['ID_MEMBER'];
				}

				if (empty($row['showOnline']))
					$context['view_num_hidden']++;
			}

		// The number of guests is equal to the rows minus the ones we actually used ;).
		$context['view_num_guests'] = mysql_num_rows($request) - count($context['view_members']);
		mysql_free_result($request);

		if (!$found_me)
</replace>

<search for>
				if (empty($row['showOnline']))
					$context['view_num_hidden']++;
			}
		}
	}
</search for>

<add after>
	// Somehow i can do the colors for this in two steps... because the split between first part and the messages...
	if (!empty($MemberColor_ID_MEMBER)) {
		//Now Load the Missing global :)
		global $user_profile;

		loadMemberData($MemberColor_ID_MEMBER);

		//Color for the who is online ;)
		if (!empty($settings['display_who_viewing']) && !empty($modSettings['MemberColorWhoIsOnline']) && !empty($settings['display_who_viewing'])) 
			foreach($context['view_members'] as $key => $value) {
				if (!isset($keyx)) $keyx = $key;
				$profile = &$user_profile[$value['id']];
				//Let's replace Who is online colors...
				$hidden_user = $context['view_members'][$key]['hidden'];
				if(!empty($profile['member_group_color']) || !empty($profile['post_group_color'])) {
					$context['view_members'][$key]['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><font color="'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).'">' . $profile['realName'] . '</font></a>';
					//Somehow the 'view_members_list' must be the same as before *g*, i don't like the hidden users...
					if (!$hidden_user || allowedTo('moderate_forum')) { 
						$context['view_members_list'][$keyx] = ($hidden_user ? '<i>' : '').'<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><font color="'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).'">' . $profile['realName'] . '</font></a>'.($hidden_user ? '</i>' : '');
						$keyx++;
					}
				}
				elseif (!$hidden_user || allowedTo('moderate_forum'))
					$keyx++;
			}
	}
</add after>

<edit file>
$sourcedir/Recent.php
</edit file>

<search for>
	$posts = array();
</search for>

<add after>
	if (!empty($modSettings['MemberColorRecentLastPost']))
		$MemberColor_ID_MEMBER = array();	
</add after>

<search for>
		);
	}
	mysql_free_result($request);

	return $posts;
}
</search for>

<replace>
		);

		//The Last Posters id for the MemberColor.
		if (!empty($modSettings['MemberColorRecentLastPost']) && !empty($row['ID_MEMBER']))
				$MemberColor_ID_MEMBER[$row['ID_MEMBER']] = $row['ID_MEMBER'];
	}
	mysql_free_result($request);


	// Know set the colors for the Recent posts...
	if (!empty($MemberColor_ID_MEMBER)) {
		//Now i can Load the Missing globals :)
		global $user_profile;

		loadMemberData($MemberColor_ID_MEMBER);
		$cmemcolid = NULL;

		//So Let's Color The Recent Posts ;)
		if (!empty($modSettings['MemberColorRecentLastPost']))
			if (is_array($posts))
				foreach($posts as $postkey => $postid_memcolor) {
					$cmemcolid = $postid_memcolor['poster']['id'];
					$profile = &$user_profile[$cmemcolid];
					if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
						$posts[$postkey]['poster']['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><font color="'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).'">' . $profile['realName'] . '</font></a>';
				}
	}

	return $posts;
}
</replace>

<search for>
	$counter = $_REQUEST['start'] + 1;
	$context['posts'] = array();
</search for>

<add after>
	if (!empty($modSettings['MemberColorRecentOwner']) || !empty($modSettings['MemberColorRecentLastPost']))
		$MemberColor_ID_MEMBER = array();
</add after>

<search for>
		if ($ID_MEMBER == $row['ID_FIRST_MEMBER'])
			$board_ids['own'][$row['ID_BOARD']][] = $row['ID_MSG'];
		$board_ids['any'][$row['ID_BOARD']][] = $row['ID_MSG'];
	}
	mysql_free_result($request);
</search for>

<replace>
		if ($ID_MEMBER == $row['ID_FIRST_MEMBER'])
			$board_ids['own'][$row['ID_BOARD']][] = $row['ID_MSG'];
		$board_ids['any'][$row['ID_BOARD']][] = $row['ID_MSG'];

		//The Thread Owners id for the MemberColor.
		if (!empty($modSettings['MemberColorRecentOwner']) && !empty($row['ID_FIRST_MEMBER']))
			$MemberColor_ID_MEMBER[$row['ID_FIRST_MEMBER']] = $row['ID_FIRST_MEMBER'];
		//The Last Posters id for the MemberColor.
		if (!empty($modSettings['MemberColorRecentLastPost']) && !empty($row['ID_MEMBER']))
			$MemberColor_ID_MEMBER[$row['ID_MEMBER']] = $row['ID_MEMBER'];
	}
	mysql_free_result($request);

	// Know set the colors for the Recent posts...
	if (!empty($MemberColor_ID_MEMBER)) {
		//Now i can Load the Missing global :)
		global $user_profile;

		loadMemberData($MemberColor_ID_MEMBER);
		$cmemcolid = NULL;

		//So Let's Color The Recent Posts ;)
		if (is_array($context['posts']))
			foreach($context['posts'] as $postkey => $postid_memcolor) {
				if (!empty($modSettings['MemberColorRecentLastPost'])) {
					$cmemcolid = $postid_memcolor['poster']['id'];
					$profile = &$user_profile[$cmemcolid];
					if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
						$context['posts'][$postkey]['poster']['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><font color="'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).'">' . $profile['realName'] . '</font></a>';
				}
				if (!empty($modSettings['MemberColorRecentOwner'])) {
					$cmemcolid = $postid_memcolor['first_poster']['id'];
					$profile = &$user_profile[$cmemcolid];
					if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
						$context['posts'][$postkey]['first_poster']['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><font color="'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).'">' . $profile['realName'] . '</font></a>';
				}
			}
	}
</replace>

<search for>
	$context['topics'] = array();
	$topic_ids = array();
</search for>

<add after>
	if (!empty($modSettings['MemberColorRecentOwner']) || !empty($modSettings['MemberColorRecentLastPost']))
		$MemberColor_ID_MEMBER = array();
</add after>

<search for>
		);

		determineTopicClass($context['topics'][$row['ID_TOPIC']]);
	}
	mysql_free_result($request);

	if ($is_topics && !empty($modSettings['enableParticipation']) && !empty($topic_ids))
</search for>

<replace>
		);

		//The Thread Owners id for the MemberColor.
		if (!empty($modSettings['MemberColorRecentOwner']) && !empty($row['ID_FIRST_MEMBER']))
			$MemberColor_ID_MEMBER[$row['ID_FIRST_MEMBER']] = $row['ID_FIRST_MEMBER'];
		//The Last Posters id for the MemberColor.
		if (!empty($modSettings['MemberColorRecentLastPost']) && !empty($row['ID_LAST_MEMBER']))
			$MemberColor_ID_MEMBER[$row['ID_LAST_MEMBER']] = $row['ID_LAST_MEMBER'];

		determineTopicClass($context['topics'][$row['ID_TOPIC']]);
	}
	mysql_free_result($request);

	// Know set the colors for the Recent posts...
	if (!empty($settings['display_who_viewing']) && !empty($MemberColor_ID_MEMBER)) {
		//Now i can Load the Missing global :)
		global $user_profile;

		loadMemberData($MemberColor_ID_MEMBER);
		$cmemcolid = NULL;

		//So Let's Color The Recent Posts ;)
		if (is_array($context['topics']))
			foreach($context['topics'] as $postkey => $postid_memcolor) {
				if (!empty($modSettings['MemberColorRecentLastPost'])) {
					$cmemcolid = $postid_memcolor['last_post']['member']['id'];
					$profile = &$user_profile[$cmemcolid];
					if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
						$context['topics'][$postkey]['last_post']['member']['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><font color="'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).'">' . $profile['realName'] . '</font></a>';
				}
				if (!empty($modSettings['MemberColorRecentOwner'])) {
					$cmemcolid = $postid_memcolor['first_post']['member']['id'];
					$profile = &$user_profile[$cmemcolid];
					if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
						$context['topics'][$postkey]['first_post']['member']['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><font color="'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).'">' . $profile['realName'] . '</font></a>';
				}
			}
	}

	if ($is_topics && !empty($modSettings['enableParticipation']) && !empty($topic_ids))
</replace>

<edit file>
$sourcedir/PersonalMessage.php
</edit file>

<search for>
	$context['allow_hide_email'] = !empty($modSettings['allow_hideEmail']);
	$context['from_or_to'] = $context['folder'] != 'outbox' ? 'from' : 'to';
	$context['get_pmessage'] = 'prepareMessageContext';

	$labelQuery = $context['folder'] != 'outbox' ? "
			AND FIND_IN_SET('$context[current_label_id]', pmr.labels)" : '';
</search for>

<add after>
	//Correct a Modsettings sometime there is a problem, and load variables if i need them ;).
	$colormodcheck = 'MemberColorInbox';
	if ($context['folder'] == 'outbox') $colormodcheck = 'MemberColorOutbox';
	$MemberSetColor = FALSE;
	if (empty($modSettings[$colormodcheck]) && !empty($modSettings['MemberColorLink'])) 
		$modSettings['MemberColorLink'] = NULL;
	if (!empty($modSettings[$colormodcheck])) {
		$MemberColor_ID_MEMBER = array();
		$MemberColor_IM_ID = array();
	}
</add after>

<search for>
		}
		mysql_free_result($request);

		// Load any users....
		$posters = array_unique($posters);
		if (!empty($posters))
			loadMemberData($posters);
</search for>

<replace>
			if (!empty($row['ID_MEMBER_TO']) && !empty($modSettings[$colormodcheck])) {
				$MemberSetColor = TRUE;
				$posters[] = $row['ID_MEMBER_TO'];
				// Hmmm somehow i must know what i should replace... i hope i do it right...
				$MemberColor_IM_ID[$row['ID_PM']][empty($row['bcc']) ? 'to' : 'bcc'][] = $row['ID_MEMBER_TO'];
			}
			elseif (empty($row['ID_MEMBER_TO']) && (!empty($modSettings['MemberColorOutbox']) || !empty($modSettings['MemberColorInbox']))) 
				$MemberColor_IM_ID[$row['ID_PM']][empty($row['bcc']) ? 'to' : 'bcc'][] = NULL;
		}

		// Load any users....
		$posters = array_unique($posters);
		if (!empty($posters))
			loadMemberData($posters);

		//So i must correct the link ;) i need only the membercontext for this (a little bit faster)
		if ($MemberSetColor && !empty($MemberColor_IM_ID)) {
			//Now i can Load the Missing global :)
			global $user_profile;
	
			//So let's replace the links...
			foreach($MemberColor_IM_ID as $pmid => $pmidarray) {
				if (!empty($pmidarray['to'])) 
					foreach($pmidarray['to'] as $pm_meber_key => $pm_member_id) {
						if(!empty($recipients[$pmid]['to'][$pm_meber_key]) && (!empty($user_profile[$pm_member_id]['member_group_color']) || !empty($user_profile[$pm_member_id]['post_group_color']))) {
							$profile = $user_profile[$pm_member_id];
							$recipients[$pmid]['to'][$pm_meber_key] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><font color="'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).'">' . $profile['realName'] . '</font></a>';
						}
					}
				if (!empty($pmidarray['bcc'])) 					
					foreach($pmidarray['bcc']  as $pm_meber_key => $pm_member_id) {
						if(!empty($recipients[$pmid]['bcc'][$pm_meber_key]) && (!empty($user_profile[$pm_member_id]['member_group_color']) || !empty($user_profile[$pm_member_id]['post_group_color']))) {
							$profile = $user_profile[$pm_member_id];
							$recipients[$pmid]['bcc'][$pm_meber_key] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><font color="'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).'">' . $profile['realName'] . '</font></a>';
						}
					}
			}
		}
</replace>

<edit file>
$sourcedir/Stats.php
</edit file>

<search for>
		$context['top_posters'][] = array(
			'name' => $row_members['realName'],
			'id' => $row_members['ID_MEMBER'],
			'num_posts' => $row_members['posts'],
			'href' => $scripturl . '?action=profile;u=' . $row_members['ID_MEMBER'],
			'link' => '<a href="' . $scripturl . '?action=profile;u=' . $row_members['ID_MEMBER'] . '">' . $row_members['realName'] . '</a>'
		);
</search for>

<add after>
		
		if (!empty($modSettings['MemberColorStats']))
			$MemberColor_ID_MEMBER[$row_members['ID_MEMBER']] = $row_members['ID_MEMBER'];
</add after>

<search for>
		$context['top_boards'][] = array(
			'id' => $row_board['ID_BOARD'],
			'name' => $row_board['name'],
			'num_posts' => $row_board['numPosts'],
			'href' => $scripturl . '?board=' . $row_board['ID_BOARD'] . '.0',
			'link' => '<a href="' . $scripturl . '?board=' . $row_board['ID_BOARD'] . '.0">' . $row_board['name'] . '</a>'
		);
</search for>

<add after>

		if (!empty($modSettings['MemberColorStats']))
			$MemberColor_ID_MEMBER[$row_members['ID_MEMBER_STARTED']] = $row_members['ID_MEMBER_STARTED'];
</add after>

<search for>
		$context['top_time_online'][] = array(
			'id' => $row_members['ID_MEMBER'],
			'name' => $row_members['realName'],
			'time_online' => $timelogged,
			'seconds_online' => $row_members['totalTimeLoggedIn'],
			'href' => $scripturl . '?action=profile;u=' . $row_members['ID_MEMBER'],
			'link' => '<a href="' . $scripturl . '?action=profile;u=' . $row_members['ID_MEMBER'] . '">' . $row_members['realName'] . '</a>'
		);
</search for>

<add after>

		if (!empty($modSettings['MemberColorStats']))
			$MemberColor_ID_MEMBER[$row_members['ID_MEMBER']] = $row_members['ID_MEMBER'];
</add after>

<search for>
	foreach ($context['top_time_online'] as $i => $member)
		$context['top_time_online'][$i]['time_percent'] = round(($member['seconds_online'] * 100) / $max_time_online);
</search for>

<add after>
	
	if (!empty($modSettings['latestMember']) && !empty($modSettings['MemberColorLatestMember']))
		$MemberColor_ID_MEMBER[$modSettings['latestMember']] = $modSettings['latestMember'];
	
	//Yeah baby give me some colors =).
	if (!empty($MemberColor_ID_MEMBER)) {
		//Now Load the Missing global :)
		global $user_profile;
		loadMemberData($MemberColor_ID_MEMBER);
		$cmemcolid = NULL;
		if (!empty($modSettings['MemberColorStats'])) {
			// First the Top Posters =)
			foreach($context['top_posters'] as $key => $value) {
				$cmemcolid = $context['top_posters'][$key]['id'];
				$profile = &$user_profile[$cmemcolid];
				if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
					$context['top_posters'][$key]['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><font color="'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).'">' . $profile['realName'] . '</font></a>';
			}
			// First the Top Starter =)		
			foreach($context['top_starters'] as $key => $value) {
				$cmemcolid = $context['top_starters'][$key]['id'];
				$profile = &$user_profile[$cmemcolid];
				if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
					$context['top_starters'][$key]['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><font color="'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).'">' . $profile['realName'] . '</font></a>';
			}
			// First the Top Onliner =)				
			foreach($context['top_time_online'] as $key => $value) {
				$cmemcolid = $context['top_time_online'][$key]['id'];
				$profile = &$user_profile[$cmemcolid];
				if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
					$context['top_time_online'][$key]['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><font color="'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).'">' . $profile['realName'] . '</font></a>';
			}
		}
		if (!empty($modSettings['latestMember']) && !empty($modSettings['MemberColorLatestMember'])) {
			$profile = &$user_profile[$modSettings['latestMember']];
			if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
				$context['latest_member']['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><font color="'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).'">' . $profile['realName'] . '</font></a>';
		}
	}
</add after>

<edit file>
$sourcedir/Subs.php
</edit file>

<search for>
	// This looks weird, but it's because BoardIndex.php references the variable.
	$context['common_stats']['latest_member'] = array(
		'id' => $modSettings['latestMember'],
		'name' => $modSettings['latestRealName'],
		'href' => $scripturl . '?action=profile;u=' . $modSettings['latestMember'],
		'link' => '<a href="' . $scripturl . '?action=profile;u=' . $modSettings['latestMember'] . '">' . $modSettings['latestRealName'] . '</a>',
	);
</search for>

<add after>
	//Latest user need some colors... How could you put this into this file... i hate you... i hope no one read this :P
	if (!empty($modSettings['latestMember']) && !empty($modSettings['MemberColorLatestMember'])) {
		global $user_profile;
		loadMemberData($modSettings['latestMember']);
		$profile = &$user_profile[$modSettings['latestMember']];
		if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
			$context['common_stats']['latest_member']['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><font color="'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).'">' . $profile['realName'] . '</font></a>';
	}
</add after>

<edit file>
Themes/default/Calendar.template.php
</edit file>

<search for>
						<a href="', $scripturl, '?action=profile;u=', $member['id'], '">', $member['name'], isset($member['age']) ? ' (' . $member['age'] . ')' : '', '</a>', $member['is_last'] ? '' : ', ';
</search for>

<replace>
						<a href="', $scripturl, '?action=profile;u=', $member['id'], '">', (!empty($member['color']) ? '<font color="'.$member['color'].'">' : ''), $member['name'], isset($member['age']) ? ' (' . $member['age'] . ')' : '', (!empty($member['color']) ? '</font>' : ''), '</a>', $member['is_last'] ? '' : ', ';
</replace>

<edit file>
Themes/default/BoardIndex.template.php
</edit file>

<search for>
				<a href="', $scripturl, '?action=profile;u=', $member['id'], '">', $member['is_today'] ? '<b>' : '', $member['name'], $member['is_today'] ? '</b>' : '', isset($member['age']) ? ' (' . $member['age'] . ')' : '', '</a>', $member['is_last'] ? '<br />' : ', ';
</search for>

<replace>
				<a href="', $scripturl, '?action=profile;u=', $member['id'], '">', (!empty($member['color']) ? '<font color="'.$member['color'].'">' : ''), $member['name'], isset($member['age']) ? ' (' . $member['age'] . ')' : '', (!empty($member['color']) ? '</font>' : ''), '</a>', $member['is_last'] ? '' : ', ';
</replace>
