<id>
din1031:MemberColorLink
</id>

<version>
2.1.5a
</version>

<edit file>
$sourcedir/Admin.php
</edit file>

<search for>
						'layout' => array($txt['mods_cat_layout']),
</search for>

<replace>
						'layout' => array($txt['mods_cat_layout']),
						'MemberColorLinks' => array($txt['MemberColorLinkHeadline']),
</replace>

<edit file>
$sourcedir/ManageSettings.php
</edit file>

<search for>
		'layout' => 'ModifyLayoutSettings',
</search for>

<replace>
		'layout' => 'ModifyLayoutSettings',
		'MemberColorLinks' => 'ModifyMemberColorLinksSettings',
</replace>

<search for>
			'layout' => array(
			),
</search for>

<replace>
			'layout' => array(
			),
			'MemberColorLinks' => array(
			),
</replace>

<search for>
function ModifyKarmaSettings($return_config = false)
{
	global $txt, $scripturl, $context, $settings, $sc;
</search for>

<add before>
function ModifyMemberColorLinksSettings($return_config = false)
{
	global $txt, $scripturl, $context, $settings, $sc;

	$config_vars = array(
			// Standard Membercolor?
			array('check', 'MemberColorLink'),
		'',
			//Some Stat Settings
			array('check', 'MemberColorLatestMember'),
			array('check', 'MemberColorStats'),
			array('check', 'MemberColorWhoIsOnline'),
		'',
			//Thread and Boardsettings
			array('check', 'MemberColorThreadOwner'),
			array('check', 'MemberColorThreadLastPost'),
			array('check', 'MemberColorThreadChild'),
		'',
			//Birthday and Calendar 
			array('check', 'MemberColorModeratorLinks'),
			array('check', 'MemberColorBoardindex'),
			array('check', 'MemberColorBirthday'),
		'',
			//Some Recent Things
			array('check', 'MemberColorRecentOwner'),
			array('check', 'MemberColorRecentLastPost'),
		'',
			// PM Colors
			array('check', 'MemberColorInbox'),
			array('check', 'MemberColorOutbox'),
		'',
			//Guest Color
			array('text', 'MemberColorGuests'),
			//Banned User Color
			array('text', 'MemberColorBanned'),
	);

	if ($return_config)
		return $config_vars;

	// Saving?
	if (isset($_GET['save']))
	{
		saveDBSettings($config_vars);
		redirectexit('action=admin;area=featuresettings;sa=MemberColorLinks');
	}

	$context['post_url'] = $scripturl . '?action=admin;area=featuresettings;save;sa=MemberColorLinks';
	$context['settings_title'] = $txt['MemberColorLinkHeadline'];

	prepareDBSettingContext($config_vars);
}
</add before>

<edit file>
$sourcedir/Load.php
</edit file>

<search for>
	array loadMemberData(array members, bool is_name = false, string set = 'normal')
</search for>

<replace>
	array loadOnlineColors(array members, bool returnarray = true)
		- This function is for Modcreators who like to color the nicks if the MemberColorLink is installed
		  with this function the user can check if the function exists and load the colors if needed.
		  But please load so many ids as possible at one time, to reduce the database querys.
		  To Check if the function exist use if(function_exists('loadOnlineColors')) {}
		- return a array with follow informations
			array(id_member => array(online_color => '', colored_name => '', colored_link => '');
		- chache datas the global $color_profile (only the db data, not the array data above)
		- return "false" on nothing loaded!

	array loadMemberData(array members, bool is_name = false, string set = 'normal')
</replace>

<search for>
			$user_profile[$row['id_member']] = $row;
</search for>

<replace>
			$user_profile[$row['id_member']] = $row;
			//Color Banned user, replace there color... hope they are not moderators ;P?
			if(!empty($modSettings['MemberColorBanned']) && isset($row['is_activated']) && $row['is_activated'] >= 10) {
				$user_profile[$row['id_member']]['post_group_color'] = $modSettings['MemberColorBanned'];
				$user_profile[$row['id_member']]['member_group_color'] = $modSettings['MemberColorBanned'];
			}
</replace>

<search for>
		'username' => $profile['member_name'],
		'name' => $profile['real_name'],
</search for>

<replace>
		'username' => $profile['member_name'],
		'name' => $profile['real_name'],
		'colored_name' => (!empty($profile['member_group_color']) || !empty($profile['post_group_color']) ? '<span style="color:'. ( !empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color'] ) .';">' : '' ) . $profile['real_name'] . (!empty($profile['member_group_color']) || !empty($profile['post_group_color']) ? '</span>' : ''),
		'online_color' => (!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']),
</replace>

<search for>
		'link' => '<a href="' . $scripturl . '?action=profile;u=' . $profile['id_member'] . '" title="' . $txt['profile_of'] . ' ' . $profile['real_name'] . '">' . $profile['real_name'] . '</a>',
</search for>

<replace>
		'link' => '<a href="' . $scripturl . '?action=profile;u=' . $profile['id_member'] . '" title="' . $txt['profile_of'] . ' ' . $profile['real_name'] . '">' . (!empty($modSettings['MemberColorLink']) ? ( !empty($profile['member_group_color']) || !empty($profile['post_group_color']) ? '<span style="color:'. ( !empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color'] ) .';">' : '' ) : '' ) . $profile['real_name'] . (!empty($modSettings['MemberColorLink']) && (!empty($profile['member_group_color']) || !empty($profile['post_group_color'])) ? '</span>' : '' ).'</a>',
		'colorless_link' => '<a href="' . $scripturl . '?action=profile;u=' . $profile['id_member'] . '" title="' . $txt['profile_of'] . ' ' . $profile['real_name'] . '">' . $profile['real_name'] . '</a>',
</replace>

<search for>
// Load a theme, by ID.
</search for>

<replace>
//This is the universal load colors function, can be used by each person who need it :)
//I think it's intressting for mod Creators =D
//SMF 2.x Version
function load_onlineColors($users, $returnarray = true) {
	global $color_profile, $modSettings, $smcFunc;

	//Make something for sure :)
	if(!isset($color_profile))
		$color_profile = array();
	//Set a standard empty array for guest errors ;) (Deleted users, which are not resetet)
	if(!isset($color_profile[0]))
		$color_profile[0] = array('member_group_color' => '', 'post_group_color' => '');
	
	// Can't just look for no users :P.
	if (empty($users))
		return false;

	// Make sure it's an array.
	$users = !is_array($users) ? array($users) : array_unique($users);

	//Now i will use this as a chache, too
	$loaded_ids = array();
	$all_loaded_ids = array_keys($color_profile);
	//All the users that allready loaded
	$loaded_ids = array_intersect($all_loaded_ids, $users);
	//Now i need only the new users to load
	$users = array_diff($users, $all_loaded_ids);

	// Load the data.
	if(!empty($users)) {
		$request = $smcFunc['db_query']('', "
			SELECT
			mem.id_member AS id_member, mem.real_name AS real_name,
			mg.online_color AS member_group_color, IFNULL(mg.group_name, '') AS member_group,
			pg.online_color AS post_group_color, IFNULL(pg.group_name, '') AS post_group
			FROM {db_prefix}members AS mem
			LEFT JOIN {db_prefix}membergroups AS pg ON (pg.ID_GROUP = mem.ID_POST_GROUP)
			LEFT JOIN {db_prefix}membergroups AS mg ON (mg.ID_GROUP = mem.ID_GROUP)
			WHERE mem.id_member ".(count($users) == 1 ? " = '" . current($users) . "'" : " IN ('" . implode("', '", $users) . "')"));

		while ($row = $smcFunc['db_fetch_assoc']($request))
		{
			$loaded_ids[] = $row['id_member'];
			$color_profile[$row['id_member']] = $row;
		}
		$smcFunc['db_free_result']($request);
	}
	
	//Build the Array ;D
	$array = array();
	if(!empty($loaded_ids) && $returnarray == true) {
		global $txt, $scripturl;
		foreach($loaded_ids as $id) {
			$profile = $color_profile[$id];
			$onlineColor = !empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color'];
			$array[$id] = array(
				'id' => $id,
				'online_color' => $onlineColor,
				'colored_name' => (!empty($onlineColor) ? '<span style="color:'. $onlineColor .';">' : '' ) . $profile['real_name'] . (!empty($onlineColor) ? '</span>' : ''),
				'colored_link' => '<a href="' . $scripturl . '?action=profile;u=' . $profile['id_member'] . '" title="' . $txt['profile_of'] . ' ' . $profile['real_name'] . '"'.(!empty($onlineColor) ? ' style="color:'.$onlineColor.';"' : '').'>' . $profile['real_name'] . '</a>',
			);
		}	
	}
	//Return that what should returned XD
	return (empty($loaded_ids) ? false : ($returnarray == true ? $array : $loaded_ids));
}

// Load a theme, by ID.
</replace>

<edit file>
$sourcedir/Subs-BoardIndex.php
</edit file>

<search for>
			if (!empty($row_board['id_moderator']))
			{
</search for>

<replace>
			if (!empty($row_board['id_moderator']))
			{
				//Color the Mods, too...
				if(!empty($modSettings['MemberColorModeratorLinks'])) {
					$context['MemberColor_ID_MEMBER'][$row_board['id_moderator']] = $row_board['id_moderator'];
					if(!empty($row_board['id_cat']))
						$context['MemberColor_ModBoard'][$isChild ? $row_board['id_parent'] : $row_board['id_board']] = array(
							'bid' => ($isChild ? $row_board['id_parent'] : $row_board['id_board']),
							'cat' => (!empty($row_board['id_cat']) ? $row_board['id_cat'] : 0));
				}
</replace>

<search for>
				'link' => $row_board['poster_name'] != '' ? (!empty($row_board['id_member']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row_board['id_member'] . '">' . $row_board['real_name'] . '</a>' : $row_board['real_name']) : $txt['not_applicable'],
</search for>

<replace>
				'link' => $row_board['poster_name'] != '' ? (!empty($row_board['id_member']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row_board['id_member'] . '">' . $row_board['real_name'] . '</a>' : (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$row_board['real_name'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '')) : $txt['not_applicable'],
</replace>

<search for>
		// Provide the href and link.
		if ($row_board['subject'] != '')
		{
			$this_last_post['href'] = $scripturl . '?topic=' . $row_board['id_topic'] . '.msg' . ($user_info['is_guest'] ? $modSettings['maxMsgID'] : $row_board['new_from']) . (empty($row_board['is_read']) ? ';boardseen' : '') . '#new';
</search for>

<add before>
		//Some things i need for the Membercolor Link :)
		if (!empty($row_board['id_member']))
			$context['MemberColor_ID_MEMBER'][$row_board['id_member']] = $row_board['id_member'];
		if (!empty($modSettings['MemberColorBoardindex']) && !empty($row_board['id_member'])) {
			$context['MemberColor_board'][$isChild ? $row_board['id_parent'] : $row_board['id_board']] = array(
			'bid' => ($isChild ? $row_board['id_parent'] : $row_board['id_board']),
			'cat' => (!empty($row_board['id_cat']) ? $row_board['id_cat'] : 0));
		}
</add before>

<edit file>
$sourcedir/MessageIndex.php
</edit file>

<search for>
	$context['name'] = $board_info['name'];
	$context['description'] = $board_info['description'];
</search for>

<add before>
	//Set some standard Variables for the MemberColorLink
	$context['MemberColor_ID_MEMBER'] = array();
</add before>

<search for>
	if (!empty($board_info['moderators']))
	{
		foreach ($board_info['moderators'] as $mod)
			$context['link_moderators'][] ='<a href="' . $scripturl . '?action=profile;u=' . $mod['id'] . '" title="' . $txt['board_moderator'] . '">' . $mod['name'] . '</a>';
</search for>

<replace>
	if (!empty($board_info['moderators']))
	{
		//I hate it in this way... but what should i do ;)
		if(!empty($modSettings['MemberColorModeratorLinks'])) {
			global $user_profile;

			foreach($board_info['moderators'] as $mod)
				$c[$mod['id']] = $mod['id'];

			loadMemberData($c);
		
			foreach ($board_info['moderators'] as $mod) {
				$cmemcolid = $mod['id'];
				$profile = &$user_profile[$cmemcolid];
					
				if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
					$context['link_moderators'][] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['id_member'] . '" title="' . $txt['board_moderator'] . ' ' . $profile['real_name'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['real_name'] . '</span></a>';
				else
					$context['link_moderators'][] = '<a href="' . $scripturl . '?action=profile;u=' . $mod['id'] . '" title="' . $txt['board_moderator'] . '">' . $mod['name'] . '</a>';
			}
		}
		else
			foreach ($board_info['moderators'] as $mod)
				$context['link_moderators'][] = '<a href="' . $scripturl . '?action=profile;u=' . $mod['id'] . '" title="' . $txt['board_moderator'] . '">' . $mod['name'] . '</a>';
</replace>

<search for>
			if (!empty($row['online_color']))
				$link = '<a href="' . $scripturl . '?action=profile;u=' . $row['id_member'] . '" style="color: ' . $row['online_color'] . ';">' . $row['real_name'] . '</a>';
</search for>

<replace>
			if (!empty($row['online_color']) && !empty($modSettings['MemberColorWhoIsOnline']))
				$link = '<a href="' . $scripturl . '?action=profile;u=' . $row['id_member'] . '" style="color: ' . $row['online_color'] . ';">' . $row['real_name'] . '</a>';
</replace>

<search for>
			if (!$pre_query)
				$topic_ids[] = $row['id_topic'];
</search for>

<replace>
			if (!$pre_query)
				$topic_ids[] = $row['id_topic'];

			//I need to collect some IDs for the MemberColor :).
			if (!empty($modSettings['MemberColorThreadOwner']) && !empty($row['first_id_member'])) 
					$context['MemberColor_ID_MEMBER'][$row['first_id_member']] = $row['first_id_member'];
			//Oh i need the Last Post ID, too ;)
			if (!empty($modSettings['MemberColorThreadLastPost']) && !empty($row['last_id_member'])) 
					$context['MemberColor_ID_MEMBER'][$row['last_id_member']] = $row['last_id_member'];
</replace>

<search for>
						'link' => !empty($row['first_id_member']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['first_id_member'] . '" title="' . $txt['profile_of'] . ' ' . $row['first_display_name'] . '">' . $row['first_display_name'] . '</a>' : $row['first_display_name']
</search for>

<replace>
						'link' => !empty($row['first_id_member']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['first_id_member'] . '" title="' . $txt['profile_of'] . ' ' . $row['first_display_name'] . '">' . $row['first_display_name'] . '</a>' : (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$row['first_display_name'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '')
</replace>

<search for>
						'link' => !empty($row['last_id_member']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['last_id_member'] . '">' . $row['last_display_name'] . '</a>' : $row['last_display_name']
</search for>

<replace>
						'link' => !empty($row['last_id_member']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['last_id_member'] . '">' . $row['last_display_name'] . '</a>' : (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$row['last_display_name'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '')
</replace>

<search for>
			determineTopicClass($context['topics'][$row['id_topic']]);
		}
		$smcFunc['db_free_result']($result);
</search for>

<replace>
			determineTopicClass($context['topics'][$row['id_topic']]);
		}
		$smcFunc['db_free_result']($result);

		//Now let's replace the orginal link to the Color Link ;)
		if (!empty($context['MemberColor_ID_MEMBER'])) {
			//Now Load the Missing global :)
			global $user_profile;

			loadMemberData($context['MemberColor_ID_MEMBER']);
			$cmemcolid = null;

			//You are not know what you do ;P Colors allready loaded :D
			if(!empty($modSettings['MemberColorModeratorLinks'])) {
				//Okay now... do a heavy serach for moderators... only jokeing... but you know... it look so ugly ;)
				load_mod_color();
				foreach($context['boards'] as $ID_BOARD => $boardid_memcolor) {
					//Reset it :D
					$context['boards'][$ID_BOARD]['link_moderators'] = array();
					foreach($context['boards'][$ID_BOARD]['moderators'] as $moderators) {
						$cmemcolid = $moderators['id'];
						$profile = &$user_profile[$cmemcolid];
						if(empty($profile['member_group_color']))
							$profile['member_group_color'] = $context['modGroupColor'];
						if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
							$context[$ID_BOARD]['moderators'][$cmemcolid]['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['id_member'] . '" title="' . $txt['board_moderator'] . ' ' . $profile['real_name'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['real_name'] . '</span></a>';
	
						//Creat the new list...
						$context['boards'][$ID_BOARD]['link_moderators'][] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['id_member'] . '" title="' . $txt['board_moderator'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['real_name'] . '</span></a>';
					}
				}
			}

			//Need the Childs some Colors XD
			if (!empty($modSettings['MemberColorThreadChild'])) {
				foreach($context['boards'] as $ID_BOARD => $boardid_memcolor) {
					if(empty($context['boards'][$ID_BOARD]['last_post']['member']['id']))
						continue;
					//My Childs need a Member Color ;)
					$cmemcolid = $context['boards'][$ID_BOARD]['last_post']['member']['id'];
					$profile = &$user_profile[$cmemcolid];
					if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
						$context['boards'][$ID_BOARD]['last_post']['member']['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['id_member'] . '" title="' . $txt['profile_of'] . ' ' . $profile['real_name'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['real_name'] . '</span></a>';
				}
			}
			//The Owner or the Last Post of the thread
			if (!empty($modSettings['MemberColorThreadOwner']) || !empty($modSettings['MemberColorThreadLastPost'])) {
				foreach($topic_ids as $topicid_memcolor) {
					//First the Thread Owner Link
					if (!empty($modSettings['MemberColorThreadOwner'])) {
						$cmemcolid = $context['topics'][$topicid_memcolor]['first_post']['member']['id'];
						$profile = &$user_profile[$cmemcolid];
						if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
							$context['topics'][$topicid_memcolor]['first_post']['member']['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['id_member'] . '" title="' . $txt['profile_of'] . ' ' . $profile['real_name'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['real_name'] . '</span></a>';
					}
					//Or the Last Post Link ;)
					if (!empty($modSettings['MemberColorThreadLastPost'])) {
						$cmemcolid = $context['topics'][$topicid_memcolor]['last_post']['member']['id'];
						$profile = &$user_profile[$cmemcolid];
						if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
							$context['topics'][$topicid_memcolor]['last_post']['member']['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['id_member'] . '" title="' . $txt['profile_of'] . ' ' . $profile['real_name'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['real_name'] . '</span></a>';
					}
				}
			}
		}
</replace>

<edit file>
$sourcedir/BoardIndex.php
</edit file>

<search for>
	$context['categories'] = getBoardIndex($boardIndexOptions);
</search for>

<add after>
	//The latest member?
	if (!empty($modSettings['latestMember']) && !empty($modSettings['MemberColorLatestMember']))
		$context['MemberColor_ID_MEMBER'][$modSettings['latestMember']] = $modSettings['latestMember'];

	// Know set the colors for the last post...
	if (!empty($context['MemberColor_ID_MEMBER'])) {
		//Now i can Load the Missing global :)
		global $user_profile, $scripturl;

		loadMemberData($context['MemberColor_ID_MEMBER']);
		$cmemcolid = NULL;

		//So the BoardIndex need colored links
		if (!empty($modSettings['MemberColorBoardindex']) && !empty($context['MemberColor_board'])) {
			foreach($context['MemberColor_board'] as $boardid_memcolor) {
				$cmemcolid = $context['categories'][$boardid_memcolor['cat']]['boards'][$boardid_memcolor['bid']]['last_post']['member']['id'];
				$profile = &$user_profile[$cmemcolid];
				if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
					$context['categories'][$boardid_memcolor['cat']]['boards'][$boardid_memcolor['bid']]['last_post']['member']['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['id_member'] . '" title="' . $txt['profile_of'] . ' ' . $profile['real_name'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['real_name'] . '</span></a>';
				if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
					$context['categories'][$boardid_memcolor['cat']]['boards'][$boardid_memcolor['bid']]['last_post']['member']['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['id_member'] . '" title="' . $txt['profile_of'] . ' ' . $profile['real_name'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['real_name'] . '</span></a>';
			}
		}

		//You are not know what you do ;P Colors allready loaded :D
		if(!empty($modSettings['MemberColorModeratorLinks']) && !empty($context['MemberColor_ModBoard'])) {
			//Okay now... do a heavy serach for moderators... only jokeing... but you know... it look so ugly ;)
			load_mod_color();
			foreach($context['MemberColor_ModBoard'] as $boardid_memcolor) {
				//Reset it :D
				$context['categories'][$boardid_memcolor['cat']]['boards'][$boardid_memcolor['bid']]['link_moderators'] = array();
				foreach($context['categories'][$boardid_memcolor['cat']]['boards'][$boardid_memcolor['bid']]['moderators'] as $moderators) {
					$cmemcolid = $moderators['id'];
					$profile = &$user_profile[$cmemcolid];
					if(empty($profile['member_group_color']))
						$profile['member_group_color'] = $context['modGroupColor'];
					if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
						$context['categories'][$boardid_memcolor['cat']]['boards'][$boardid_memcolor['bid']]['moderators'][$cmemcolid]['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['id_member'] . '" title="' . $txt['board_moderator'] . ' ' . $profile['real_name'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['real_name'] . '</span></a>';

					//Creat the new list...
					$context['categories'][$boardid_memcolor['cat']]['boards'][$boardid_memcolor['bid']]['link_moderators'][] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['id_member'] . '" title="' . $txt['board_moderator'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['real_name'] . '</span></a>';
				}
			}
		}
	}
</add after>

<edit file>
$sourcedir/Subs-Calendar.php
</edit file>

<search for>
	$bday = array();
</search for>

<add after>
	$MemberSetColor = false;
	$context['MemberColor_ID_MEMBER'] = array();
</add after>

<search for>
		$bday[$age_year . substr($row['birthdate'], 4)][] = array(
			'id' => $row['id_member'],
			'name' => $row['real_name'],
			'age' => $row['birthYear'] > 4 && $row['birthYear'] <= $age_year ? $age_year - $row['birthYear'] : null,
			'is_last' => false
		);
	}
	$smcFunc['db_free_result']($result);
</search for>

<replace>
		$bday[$age_year . substr($row['birthdate'], 4)][] = array(
			'id' => $row['id_member'],
			'name' => $row['real_name'],
			'colored_name' => $row['real_name'],
			'age' => $row['birthYear'] > 4 && $row['birthYear'] <= $age_year ? $age_year - $row['birthYear'] : null,
			'is_last' => false
		);

		//I need to collect some IDs for the MemberColor :).
		if (!empty($modSettings['MemberColorBirthday']) && !empty($row['id_member']))
			$context['MemberColor_ID_MEMBER'][$row['id_member']] = $row['id_member'];
	}
	$smcFunc['db_free_result']($result);

	if (!empty($context['MemberColor_ID_MEMBER'])) {
		//No compatible Problems ;) (I hope it).
		global $user_profile;

		loadMemberData($context['MemberColor_ID_MEMBER']);
		$cmemcolid = NULL;

		//So i need only the colors... hmmm why schould i not use only the $user_profiles for this... (The Calenderlink is diffrent)
		if (!empty($modSettings['MemberColorBirthday'])) {
			if (!empty($bday) && is_array($bday)) {
				foreach ($bday as $memcalkv => $memcalva) {
					foreach ($memcalva as $memcalidkv => $memcalid) {
						$cmemcolid = $memcalid['id'];
						$profile = $user_profile[$cmemcolid];
						$bday[$memcalkv][$memcalidkv]['color'] = (!empty($profile['member_group_color']) ? $profile['member_group_color'] : (!empty($profile['post_group_color']) ? $user_profile[$cmemcolid]['post_group_color'] : ''));
						$bday[$memcalkv][$memcalidkv]['colored_name'] = (!empty($profile['member_group_color']) || !empty($profile['post_group_color']) ? '<span style="color:'. ( !empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color'] ) .';">' : '' ) . $profile['real_name'] . (!empty($profile['member_group_color']) || !empty($profile['post_group_color']) ? '</span>' : '');
					}
				}
			}
		}
	}
</replace>

<edit file>
$sourcedir/Display.php
</edit file>

<search for>
	if (!empty($board_info['moderators']))
	{
		// Add a link for each moderator...
		foreach ($board_info['moderators'] as $mod)
			$context['link_moderators'][] = '<a href="' . $scripturl . '?action=profile;u=' . $mod['id'] . '" title="' . $txt['board_moderator'] . '">' . $mod['name'] . '</a>';
</search for>

<replace>
	if (!empty($board_info['moderators']))
	{
		//I hate it in this way... but what should i do ;)
		if(!empty($modSettings['MemberColorModeratorLinks'])) {
			global $user_profile;

			foreach($board_info['moderators'] as $mod)
				$c[$mod['id']] = $mod['id'];

			loadMemberData($c);
		
			foreach ($board_info['moderators'] as $mod) {
				$cmemcolid = $mod['id'];
				$profile = &$user_profile[$cmemcolid];
					
				if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
					$context['link_moderators'][] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['id_member'] . '" title="' . $txt['board_moderator'] . ' ' . $profile['real_name'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['real_name'] . '</span></a>';
				else
					$context['link_moderators'][] = '<a href="' . $scripturl . '?action=profile;u=' . $mod['id'] . '" title="' . $txt['board_moderator'] . '">' . $mod['name'] . '</a>';
			}
		}
		else
			foreach ($board_info['moderators'] as $mod)
				$context['link_moderators'][] = '<a href="' . $scripturl . '?action=profile;u=' . $mod['id'] . '" title="' . $txt['board_moderator'] . '">' . $mod['name'] . '</a>';
</replace>

<search for>
			if (!empty($row['online_color']))
				$link = '<a href="' . $scripturl . '?action=profile;u=' . $row['id_member'] . '" style="color: ' . $row['online_color'] . ';">' . $row['real_name'] . '</a>';
</search for>

<replace>
			if (!empty($row['online_color']) && !empty($modSettings['MemberColorWhoIsOnline']))
				$link = '<a href="' . $scripturl . '?action=profile;u=' . $row['id_member'] . '" style="color: ' . $row['online_color'] . ';">' . $row['real_name'] . '</a>';
</replace>

<search for>
		$memberContext[$message['id_member']]['group'] = $txt['guest_title'];
		$memberContext[$message['id_member']]['link'] = $message['poster_name'];
</search for>

<replace>
		$memberContext[$message['id_member']]['group'] = $txt['guest_title'];
		$memberContext[$message['id_member']]['link'] = (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$message['poster_name'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '');
</replace>

<edit file>
$sourcedir/Recent.php
</edit file>

<search for>
				'link' => empty($row['id_first_member']) ? $row['first_poster_name'] : '<a href="' . $scripturl . '?action=profile;u=' . $row['id_first_member'] . '">' . $row['first_poster_name'] . '</a>'
</search for>

<replace>
				'link' => empty($row['first_id_member']) ? (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$row['first_poster_name'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '') : '<a href="' . $scripturl . '?action=profile;u=' . $row['first_id_member'] . '" title="' . $txt['profile_of'] . ' ' . $row['first_poster_name'] . '">' . $row['first_poster_name'] . '</a>'
</replace>

<search for>
				'link' => empty($row['id_member']) ? $row['poster_name'] : '<a href="' . $scripturl . '?action=profile;u=' . $row['id_member'] . '">' . $row['poster_name'] . '</a>'
</search for>

<replace>
				'link' => empty($row['id_member']) ? (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$row['poster_name'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '') : '<a href="' . $scripturl . '?action=profile;u=' . $row['id_member'] . '" title="' . $txt['profile_of'] . ' ' . $row['poster_name'] . '">' . $row['poster_name'] . '</a>'
</replace>

<search for>
	$counter = $_REQUEST['start'] + 1;
	$context['posts'] = array();
</search for>

<add after>
	$context['MemberColor_ID_MEMBER'] = array();
</add after>

<search for>
		if ($user_info['id'] == $row['id_first_member'])
			$board_ids['own'][$row['id_board']][] = $row['id_msg'];
		$board_ids['any'][$row['id_board']][] = $row['id_msg'];
	}
	$smcFunc['db_free_result']($request);
</search for>

<replace>
		if ($user_info['id'] == $row['id_first_member'])
			$board_ids['own'][$row['id_board']][] = $row['id_msg'];
		$board_ids['any'][$row['id_board']][] = $row['id_msg'];

		//The Thread Owners id for the MemberColor.
		if (!empty($modSettings['MemberColorRecentOwner']) && !empty($row['id_first_member']))
			$context['MemberColor_ID_MEMBER'][$row['id_first_member']] = $row['id_first_member'];
		//The Last Posters id for the MemberColor.
		if (!empty($modSettings['MemberColorRecentLastPost']) && !empty($row['id_member']))
			$context['MemberColor_ID_MEMBER'][$row['id_member']] = $row['id_member'];
	}
	$smcFunc['db_free_result']($request);

	// Know set the colors for the Recent posts...
	if (!empty($context['MemberColor_ID_MEMBER'])) {
		//Now i can Load the Missing global :)
		global $user_profile;

		loadMemberData($context['MemberColor_ID_MEMBER']);
		$cmemcolid = NULL;

		//So Let's Color The Recent Posts ;)
		if (is_array($context['posts']))
			foreach($context['posts'] as $postkey => $postid_memcolor) {
				if (!empty($modSettings['MemberColorRecentLastPost'])) {
					$cmemcolid = $postid_memcolor['poster']['id'];
					$profile = &$user_profile[$cmemcolid];
					if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
						$context['posts'][$postkey]['poster']['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['id_member'] . '" title="' . $txt['profile_of'] . ' ' . $profile['real_name'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['real_name'] . '</span></a>';
				}
				if (!empty($modSettings['MemberColorRecentOwner'])) {
					$cmemcolid = $postid_memcolor['first_poster']['id'];
					$profile = &$user_profile[$cmemcolid];
					if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
						$context['posts'][$postkey]['first_poster']['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['id_member'] . '" title="' . $txt['profile_of'] . ' ' . $profile['real_name'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['real_name'] . '</span></a>';
				}
			}
	}
</replace>

<search for>
	$context['topics'] = array();
	$topic_ids = array();
</search for>

<add after>
	$context['MemberColor_ID_MEMBER'] = array();
</add after>

<search for>
					'link' => !empty($row['id_first_member']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['id_first_member'] . '" title="' . $txt['profile_of'] . ' ' . $row['first_poster_name'] . '">' . $row['first_poster_name'] . '</a>' : $row['first_poster_name']
</search for>

<replace>
					'link' => !empty($row['first_id_member']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['first_id_member'] . '" title="' . $txt['profile_of'] . ' ' . $row['first_poster_name'] . '">' . $row['first_poster_name'] . '</a>' : (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$row['first_poster_name'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '')
</replace>

<search for>
					'link' => !empty($row['id_last_member']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['id_last_member'] . '">' . $row['last_poster_name'] . '</a>' : $row['last_poster_name']
</search for>

<replace>
					'link' => !empty($row['id_last_member']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['id_last_member'] . '" title="' . $txt['profile_of'] . ' ' . $row['last_poster_name'] . '">' . $row['last_poster_name'] . '</a>' : (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$row['last_poster_name'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '')
</replace>

<search for>
		determineTopicClass($context['topics'][$row['id_topic']]);
	}
	$smcFunc['db_free_result']($request);
</search for>

<replace>
		//The Thread Owners id for the MemberColor.
		if (!empty($modSettings['MemberColorRecentOwner']) && !empty($row['id_first_member']))
			$context['MemberColor_ID_MEMBER'][$row['id_first_member']] = $row['id_first_member'];
		//The Last Posters id for the MemberColor.
		if (!empty($modSettings['MemberColorRecentLastPost']) && !empty($row['ID_LAST_MEMBER']))
			$context['MemberColor_ID_MEMBER'][$row['ID_LAST_MEMBER']] = $row['ID_LAST_MEMBER'];

		determineTopicClass($context['topics'][$row['id_topic']]);
	}
	$smcFunc['db_free_result']($request);

	// Know set the colors for the Recent posts...
	if(!empty($context['MemberColor_ID_MEMBER'])) {
		//Now i can Load the Missing global :)
		global $user_profile;

		loadMemberData($context['MemberColor_ID_MEMBER']);
		$cmemcolid = null;

		//So Let's Color The Recent Posts ;)
		if (is_array($context['topics']) && !empty($context['topics'])) {
			foreach($context['topics'] as $postkey => $postid_memcolor) {
				if (!empty($modSettings['MemberColorRecentLastPost'])) {
					$cmemcolid = $postid_memcolor['last_post']['member']['id'];
					$profile = &$user_profile[$cmemcolid];
					if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
						$context['topics'][$postkey]['last_post']['member']['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['id_member'] . '" title="' . $txt['profile_of'] . ' ' . $profile['real_name'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['real_name'] . '</span></a>';
				}
				if (!empty($modSettings['MemberColorRecentOwner'])) {
					$cmemcolid = $postid_memcolor['first_post']['member']['id'];
					$profile = &$user_profile[$cmemcolid];
					if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
						$context['topics'][$postkey]['first_post']['member']['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['id_member'] . '" title="' . $txt['profile_of'] . ' ' . $profile['real_name'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['real_name'] . '</span></a>';
				}
			}
		}
	}
</replace>

<edit file>
$sourcedir/Subs-Recent.php
</edit file>

<search for>
	$posts = array();
</search for>

<add after>
	$context['MemberColor_ID_MEMBER'] = array();	
</add after>

<search for>
				'link' => empty($row['id_member']) ? $row['poster_name'] : '<a href="' . $scripturl . '?action=profile;u=' . $row['id_member'] . '">' . $row['poster_name'] . '</a>'
</search for>

<replace>
				'link' => empty($row['id_member']) ? (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$row['poster_name'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '') : '<a href="' . $scripturl . '?action=profile;u=' . $row['id_member'] . '" title="' . $txt['profile_of'] . ' ' . $row['poster_name'] . '">' . $row['poster_name'] . '</a>'
</replace>

<search for>
		);
	}
	$smcFunc['db_free_result']($request);

	return $posts;
}
</search for>

<replace>
		);

		//The Last Posters id for the MemberColor.
		if (!empty($modSettings['MemberColorRecentLastPost']) && !empty($row['id_member']))
				$context['MemberColor_ID_MEMBER'][$row['id_member']] = $row['id_member'];
	}
	$smcFunc['db_free_result']($request);

	// Know set the colors for the Recent posts...
	if (!empty($context['MemberColor_ID_MEMBER'])) {
		//Now i can Load the Missing globals :)
		global $user_profile;

		loadMemberData($context['MemberColor_ID_MEMBER']);
		$cmemcolid = null;

		//So Let's Color The Recent Posts ;)
		if (!empty($modSettings['MemberColorRecentLastPost']))
			if (is_array($posts))
				foreach($posts as $postkey => $postid_memcolor) {
					$cmemcolid = $postid_memcolor['poster']['id'];
					$profile = &$user_profile[$cmemcolid];
					if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
						$posts[$postkey]['poster']['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['id_member'] . '" title="' . $txt['profile_of'] . ' ' . $profile['real_name'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['real_name'] . '</span></a>';
				}
	}

	return $posts;
}
</replace>

<edit file>
$sourcedir/PersonalMessage.php
</edit file>

<search for>
	$labelQuery = $context['folder'] != 'sent' ? '
			AND FIND_IN_SET(' . $context['current_label_id'] . ', pmr.labels)' : '';
</search for>

<add after>
	//Correct a Modsettings sometime there is a problem, and load variables if i need them ;).
	$colormodcheck = 'MemberColorInbox';
	if ($context['folder'] != 'sent') $colormodcheck = 'MemberColorOutbox';
	$MemberSetColor = false;
	if (empty($modSettings[$colormodcheck]) && !empty($modSettings['MemberColorLink'])) 
		$modSettings['MemberColorLink'] = null;
	if (!empty($modSettings[$colormodcheck])) {
		$context['MemberColor_ID_MEMBER'] = array();
		$MemberColor_IM_ID = array();
	}
</add after>

<search for>
		}
		$smcFunc['db_free_result']($request);

		// Make sure we don't load unnecessary data.
		if ($context['display_mode'] == 1)
		{
			foreach ($posters as $k => $v)
				if (!in_array($k, $display_pms))
					unset($posters[$k]);
		}

		// Load any users....
		$posters = array_unique($posters);
		if (!empty($posters))
			loadMemberData($posters);
</search for>

<replace>
			if (!empty($row['id_member_to']) && !empty($modSettings[$colormodcheck])) {
				$MemberSetColor = true;
				$posters[] = $row['id_member_to'];
				// Hmmm somehow i must know what i should replace... i hope i do it right...
				$MemberColor_IM_ID[$row['id_pm']][empty($row['bcc']) ? 'to' : 'bcc'][] = $row['id_member_to'];
			}
			elseif (empty($row['id_member_to']) && (!empty($modSettings['MemberColorOutbox']) || !empty($modSettings['MemberColorInbox']))) 
				$MemberColor_IM_ID[$row['id_pm']][empty($row['bcc']) ? 'to' : 'bcc'][] = NULL;
		}
		$smcFunc['db_free_result']($request);

		// Make sure we don't load unnecessary data.
		if ($context['display_mode'] == 1)
		{
			foreach ($posters as $k => $v)
				if (!in_array($k, $display_pms))
					unset($posters[$k]);
		}

		// Load any users....
		$posters = array_unique($posters);
		if (!empty($posters))
			loadMemberData($posters);

		//So i must correct the link ;) i need only the membercontext for this (a little bit faster)
		if ($MemberSetColor && !empty($MemberColor_IM_ID)) {
			//Now i can Load the Missing global :)
			global $user_profile;
	
			//So let's replace the links...
			foreach($MemberColor_IM_ID as $pmid => $pmidarray) {
				if (!empty($pmidarray['to'])) 
					foreach($pmidarray['to'] as $pm_meber_key => $pm_member_id) {
						if(!empty($recipients[$pmid]['to'][$pm_meber_key]) && (!empty($user_profile[$pm_member_id]['member_group_color']) || !empty($user_profile[$pm_member_id]['post_group_color']))) {
							$profile = $user_profile[$pm_member_id];
							$recipients[$pmid]['to'][$pm_meber_key] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['id_member'] . '" title="' . $txt['profile_of'] . ' ' . $profile['real_name'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['real_name'] . '</span></a>';
						}
					}
				if (!empty($pmidarray['bcc'])) 					
					foreach($pmidarray['bcc']  as $pm_meber_key => $pm_member_id) {
						if(!empty($recipients[$pmid]['bcc'][$pm_meber_key]) && (!empty($user_profile[$pm_member_id]['member_group_color']) || !empty($user_profile[$pm_member_id]['post_group_color']))) {
							$profile = $user_profile[$pm_member_id];
							$recipients[$pmid]['bcc'][$pm_meber_key] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['id_member'] . '" title="' . $txt['profile_of'] . ' ' . $profile['real_name'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['real_name'] . '</span></a>';
						}
					}
			}
		}
</replace>

<edit file>
$sourcedir/Stats.php
</edit file>

<search for>
	$context['top_posters'] = array();
	$max_num_posts = 1;
</search for>

<add after>
	$context['MemberColor_ID_MEMBER'] = array();
</add after>

<search for>
		if ($max_num_posts < $row_members['posts'])
			$max_num_posts = $row_members['posts'];
</search for>

<add after>
		if (!empty($modSettings['MemberColorStats']) && !empty($row_members['id_member']))
			$context['MemberColor_ID_MEMBER'][$row_members['id_member']] = $row_members['id_member'];
</add after>

<search for>
		if ($max_num_topics < $members[$row_members['id_member']])
			$max_num_topics = $members[$row_members['id_member']];
</search for>

<add after>
		if (!empty($modSettings['MemberColorStats']))
			$context['MemberColor_ID_MEMBER'][$row_members['id_member']] = $row_members['id_member'];
</add after>

<search for>
		if ($max_time_online < $row_members['total_time_logged_in'])
			$max_time_online = $row_members['total_time_logged_in'];
</search for>

<add after>
		if (!empty($modSettings['MemberColorStats']))
			$context['MemberColor_ID_MEMBER'][$row_members['id_member']] = $row_members['id_member'];
</add after>

<search for>
	foreach ($context['top_time_online'] as $i => $member)
		$context['top_time_online'][$i]['time_percent'] = round(($member['seconds_online'] * 100) / $max_time_online);
</search for>

<add after>
	
	if (!empty($modSettings['latestMember']) && !empty($modSettings['MemberColorLatestMember']))
		$context['MemberColor_ID_MEMBER'][$modSettings['latestMember']] = $modSettings['latestMember'];
	
	//Yeah baby give me some colors =).
	if (!empty($context['MemberColor_ID_MEMBER'])) {
		//Now Load the Missing global :)
		global $user_profile;
		loadMemberData($context['MemberColor_ID_MEMBER']);
		$cmemcolid = NULL;
		if (!empty($modSettings['MemberColorStats'])) {
			// First the Top Posters =)
			foreach($context['top_posters'] as $key => $value) {
				$cmemcolid = $context['top_posters'][$key]['id'];
				$profile = &$user_profile[$cmemcolid];
				if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
					$context['top_posters'][$key]['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['id_member'] . '" title="' . $txt['profile_of'] . ' ' . $profile['real_name'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['real_name'] . '</span></a>';
			}
			// First the Top Starter =)		
			foreach($context['top_starters'] as $key => $value) {
				$cmemcolid = $context['top_starters'][$key]['id'];
				$profile = &$user_profile[$cmemcolid];
				if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
					$context['top_starters'][$key]['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['id_member'] . '" title="' . $txt['profile_of'] . ' ' . $profile['real_name'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['real_name'] . '</span></a>';
			}
			// First the Top Onliner =)				
			foreach($context['top_time_online'] as $key => $value) {
				$cmemcolid = $context['top_time_online'][$key]['id'];
				$profile = &$user_profile[$cmemcolid];
				if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
					$context['top_time_online'][$key]['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['id_member'] . '" title="' . $txt['profile_of'] . ' ' . $profile['real_name'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['real_name'] . '</span></a>';
			}
		}
		if (!empty($modSettings['latestMember']) && !empty($modSettings['MemberColorLatestMember'])) {
			$profile = &$user_profile[$modSettings['latestMember']];
			if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
				$context['latest_member']['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['id_member'] . '" title="' . $txt['profile_of'] . ' ' . $profile['real_name'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['real_name'] . '</span></a>';
		}
	}
</add after>

<edit file>
$sourcedir/Subs.php
</edit file>

<search for>
	// This looks weird, but it's because BoardIndex.php references the variable.
	$context['common_stats']['latest_member'] = array(
		'id' => $modSettings['latestMember'],
		'name' => $modSettings['latestRealName'],
		'href' => $scripturl . '?action=profile;u=' . $modSettings['latestMember'],
		'link' => '<a href="' . $scripturl . '?action=profile;u=' . $modSettings['latestMember'] . '">' . $modSettings['latestRealName'] . '</a>',
	);
</search for>

<add after>
	//Latest user need some colors... How could you put this into this file... i hate you... i hope no one read this :P
	if (!empty($modSettings['latestMember']) && !empty($modSettings['MemberColorLatestMember'])) {
		global $user_profile;
		loadMemberData($modSettings['latestMember']);
		$profile = &$user_profile[$modSettings['latestMember']];
		if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
			$context['common_stats']['latest_member']['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['id_member'] . '" title="' . $txt['profile_of'] . ' ' . $profile['real_name'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['real_name'] . '</span></a>';
	}
</add after>

<search for>
function setupMenuContext()
{
</search for>

<replace>
//Load in a fast way the Moderator color... i think i cashe it sometimes...
function load_mod_color($return = false) {
	global $context, $smcFunc;
	
	if(!isset($context['modGroupColor'])) {
		$context['modGroupColor'] = '';
		$modColor = $smcFunc['db_query']('', "
			SELECT online_color
			FROM {db_prefix}membergroups
			WHERE ID_GROUP = 3
			LIMIT 1");
		list($context['modGroupColor']) = $smcFunc['db_fetch_row']($modColor);
		$smcFunc['db_free_result']($modColor);
	}
	
	$return = (bool) $return;
	return $return ? $context['modGroupColor'] : true;
}

function setupMenuContext()
{
</replace>

<edit file>
$themedir/BoardIndex.template.php
</edit file>

<search for>
							<a href="', $scripturl, '?action=profile;u=', $member['id'], '">', $member['is_today'] ? '<b>' : '', $member['name'], $member['is_today'] ? '</b>' : '', isset($member['age']) ? ' (' . $member['age'] . ')' : '', '</a>', $member['is_last'] ? '<br />' : ', ';
</search for>

<replace>
							<a href="', $scripturl, '?action=profile;u=', $member['id'], '">', $member['is_today'] ? '<b>' : '', (!empty($member['colored_name']) ? $member['colored_name'] : $member['name']), $member['is_today'] ? '</b>' : '', isset($member['age']) ? ' (' . $member['age'] . ')' : '', '</a>', $member['is_last'] ? '' : ', ';
</replace>

<edit file>
$themedir/Calendar.template.php
</edit file>

<search for>
						<a href="', $scripturl, '?action=profile;u=', $member['id'], '">', $member['name'], isset($member['age']) ? ' (' . $member['age'] . ')' : '', '</a>', $member['is_last'] ? '' : ', ';
</search for>

<replace>
						<a href="', $scripturl, '?action=profile;u=', $member['id'], '">', (!empty($member['colored_name']) ? $member['colored_name'] : $member['name']), isset($member['age']) ? ' (' . $member['age'] . ')' : '', '</a>', $member['is_last'] ? '' : ', ';
</replace>

<search for>
						<a href="', $scripturl, '?action=profile;u=', $member['id'], '">', $member['name'], isset($member['age']) ? ' (' . $member['age'] . ')' : '', '</a>', $member['is_last'] || ($count == 10 && $use_js_hide)? '' : ', ';
</search for>

<replace>
						<a href="', $scripturl, '?action=profile;u=', $member['id'], '">', (!empty($member['colored_name']) ? $member['colored_name'] : $member['name']), isset($member['age']) ? ' (' . $member['age'] . ')' : '', '</a>', $member['is_last'] || ($count == 10 && $use_js_hide) ? '' : ', ';
</replace>
